#ifndef Model_c
#define Title "mcuo2.h Cu-O(2) chain 4Cu" 
#define Sym       1	/* x x 7 x x x x x x Symmetrien */
#define Sud       1
#define CM(JJ,tJ,tU) tU	  /* Heisenberg-,  t-J- or  Hubbard-model */
/* =========================== Gitter =========================== *
   ..    O    O    O    O 
     \  / \  / \  / \  / \              y
      Cu   Cu   Cu   Cu   ..            |
     /  \ /  \ /  \ /  \ /              +--x
   ..    O    O    O    O

 * ============================================================== */
#define N0 4		/* number of Cu-sites (4) */
#define Nc 2		/* number of orbitals per Cu-site (2) */
#define No 2		/* number of orbitals per O-site  (2) */
#define NN (N0*(Nc+2*No))
#define Nw (N0*4*(Nc*No))
#define Ne NN		/* (a b) means (a over b) = a!/((a-b)!b!) */
#define Nv (19*N0)	/* (Nc 2) + 2*(No 2) + 4*((Nc+No 2)-(Nc 2)-(No 2)) */
#define IFham1(x) x
#define IFham2(x)
#define SBase 1		/* SBase/noSBase = with/without symmetry */ 
#endif
#if Model_c
  /*  i=site 0..NN, d=translation rc=i+vec_d */
int site_move(int i,int dx,int dy,...){ return 0;} /* not used */
int initvars(){ int i,j,jw,jn,jv,k;
  jw=Nw/N0;jn=NN/N0;jv=Nv/N0;
  for(i=0;i<N0;i++){ j=((i+1<N0) ? i+1 : 0); /* nice! next Cu site */ 
    k=i*jw;
    iw[k][0]=i*jn+0; iw[k][1]=i*jn+1; wt[k]=1; k++; /* dxy0-px1 */
    iw[k][0]=i*jn+0; iw[k][1]=i*jn+2; wt[k]=1; k++; /* dxy0-px2 */
    iw[k][0]=j*jn+0; iw[k][1]=i*jn+1; wt[k]=1; k++; /* dxy3-px1 */
    iw[k][0]=j*jn+0; iw[k][1]=i*jn+2; wt[k]=1; k++; /* dxy3-px2 */
    iw[k][0]=i*jn+0; iw[k][1]=i*jn+3; wt[k]=3; k++; /* dxy0-py1 */
    iw[k][0]=i*jn+0; iw[k][1]=i*jn+4; wt[k]=3; k++; /* dxy0-py2 */
    iw[k][0]=j*jn+0; iw[k][1]=i*jn+3; wt[k]=3; k++; /* dxy3-py1 */
    iw[k][0]=j*jn+0; iw[k][1]=i*jn+4; wt[k]=3; k++; /* dxy3-py2 */
    iw[k][0]=i*jn+5; iw[k][1]=i*jn+1; wt[k]=5; k++; /* dz0-px1 */
    iw[k][0]=i*jn+5; iw[k][1]=i*jn+2; wt[k]=5; k++; /* dz0-px2 */
    iw[k][0]=j*jn+5; iw[k][1]=i*jn+1; wt[k]=5; k++; /* dz3-px1 */
    iw[k][0]=j*jn+5; iw[k][1]=i*jn+2; wt[k]=5; k++; /* dz3-px2 */
    iw[k][0]=i*jn+5; iw[k][1]=i*jn+3; wt[k]=7; k++; /* dz0-py1 */
    iw[k][0]=i*jn+5; iw[k][1]=i*jn+4; wt[k]=7; k++; /* dz0-py2 */
    iw[k][0]=j*jn+5; iw[k][1]=i*jn+3; wt[k]=7; k++; /* dz3-py1 */
    iw[k][0]=j*jn+5; iw[k][1]=i*jn+4; wt[k]=7; k++; /* dz3-py2 */
  }
  nu=N0/2;nd=N0/2+N0%2;		/* 1 per Cu */
  for(i=0;i<N0;i++){ j=((i+1<N0) ? i+1 : 0); /* nice! next Cu site */
    we[i*jn+0]= 9;  wu[i*jn+0]=13;			/* Cu dxy */
    we[i*jn+1]=10;  wu[i*jn+1]=14;			/* O1 px  */
    we[i*jn+2]=10;  wu[i*jn+2]=14;			/* O2 px */
    we[i*jn+3]=11;  wu[i*jn+3]=14;			/* O1 py */
    we[i*jn+4]=11;  wu[i*jn+4]=14;			/* O2 py */
    we[i*jn+5]=12;  wu[i*jn+5]=13;			/* Cu dz */
    k=i*jv;
    iw2[k][0]=1+i*jn;iw2[k][1]=3+i*jn;wu2[k]=16;wj2[k]=19;k++;/* O1 px-pz */
    iw2[k][0]=2+i*jn;iw2[k][1]=4+i*jn;wu2[k]=16;wj2[k]=19;k++;/* O2 px-pz */
    iw2[k][0]=0+i*jn;iw2[k][1]=5+i*jn;wu2[k]=17;wj2[k]=20;k++;/* Cu-Cu dxy-dz */
    iw2[k][0]=0+i*jn;iw2[k][1]=1+i*jn;wu2[k]=18;wj2[k]=21;k++;/* Cu-O1 dxy-px */
    iw2[k][0]=0+i*jn;iw2[k][1]=2+i*jn;wu2[k]=18;wj2[k]=21;k++;/* Cu-O2 dxy-py */
    iw2[k][0]=0+i*jn;iw2[k][1]=3+i*jn;wu2[k]=18;wj2[k]=21;k++;/* Cu-O1 dxy-px */
    iw2[k][0]=0+i*jn;iw2[k][1]=4+i*jn;wu2[k]=18;wj2[k]=21;k++;/* Cu-O2 dxy-py */
    iw2[k][0]=5+i*jn;iw2[k][1]=1+i*jn;wu2[k]=18;wj2[k]=21;k++;/* Cu-O1 dz-px */
    iw2[k][0]=5+i*jn;iw2[k][1]=2+i*jn;wu2[k]=18;wj2[k]=21;k++;/* Cu-O2 dz-py */
    iw2[k][0]=5+i*jn;iw2[k][1]=3+i*jn;wu2[k]=18;wj2[k]=21;k++;/* Cu-O1 dz-px */
    iw2[k][0]=5+i*jn;iw2[k][1]=4+i*jn;wu2[k]=18;wj2[k]=21;k++;/* Cu-O2 dz-py */
    iw2[k][0]=0+j*jn;iw2[k][1]=1+i*jn;wu2[k]=18;wj2[k]=21;k++;/* C2-O1 dxy-px */
    iw2[k][0]=0+j*jn;iw2[k][1]=2+i*jn;wu2[k]=18;wj2[k]=21;k++;/* C2-O2 dxy-py */
    iw2[k][0]=0+j*jn;iw2[k][1]=3+i*jn;wu2[k]=18;wj2[k]=21;k++;/* C2-O1 dxy-px */
    iw2[k][0]=0+j*jn;iw2[k][1]=4+i*jn;wu2[k]=18;wj2[k]=21;k++;/* C2-O2 dxy-py */
    iw2[k][0]=5+j*jn;iw2[k][1]=1+i*jn;wu2[k]=18;wj2[k]=21;k++;/* C2-O1 dz-px */
    iw2[k][0]=5+j*jn;iw2[k][1]=2+i*jn;wu2[k]=18;wj2[k]=21;k++;/* C2-O2 dz-py */
    iw2[k][0]=5+j*jn;iw2[k][1]=3+i*jn;wu2[k]=18;wj2[k]=21;k++;/* C2-O1 dz-px */
    iw2[k][0]=5+j*jn;iw2[k][1]=4+i*jn;wu2[k]=18;wj2[k]=21;k++;/* C2-O2 dz-py */
  }
/*
  N0=4,No=Nc=2 k=000000 ud=-1 E0 -6.19888764  -4.52387143  -4.38956627
  N0=4,No=Nc=2 k=000004 ud=-1 E0 -6.22713548  -4.84551274  -4.69250420
  N0=4,No=Nc=2 k=000010 ud=-1 E0 -6.41901944  -5.86194728  -4.39001316
  N0=4,No=Nc=2 k=000014 ud=-1 E0 -7.92143131  -6.40920406  -5.93471658
  N0=4,No=Nc=2 k=000000 ud=+1 E0 -7.86583051  -6.19189424  -4.63311695
  N0=4,No=Nc=2 nosym          E0 -7.92143131  -7.86583051  -7.80129649 i90=4m ud=-1
  Code2==noCode2
 */
    numpara=22;
    para[ 0]= 0.0;	/* immer 0 */
    para[ 1]=-0.8;	/* t_Cu-O  px.dxy */
    para[ 2]= 0.8;	/* t_Cu-O -px.dxy */
    para[ 3]= 0.6;	/* t_Cu-O  py.dxy */
    para[ 4]=-0.6;	/* t_Cu-O -py.dxy */
    para[ 5]=-0.8;	/* t_Cu-O  px.dz */
    para[ 6]= 0.8;	/* t_Cu-O -px.dz */
    para[ 7]= 0.6;	/* t_Cu-O  py.dz */
    para[ 8]=-0.6;	/* t_Cu-O -py.dz */
    para[ 9]=-0.5;	/* e_Cu dxy */
    para[10]= 2.6;	/* e_O  px */
    para[11]= 2.7;	/* e_O  py */
    para[12]= 0.2;	/* e_Cu dz */
    para[13]= 8.0;	/* U0_Cu dxy */
    para[14]= 4.0;	/* U0_O  px,py */
    para[15]= 0.0;	/* --- */
    para[16]= 3.2;	/* O   U  = U0 + 2 JH */
    para[17]= 6.4;	/* Cu  U  = U0 + 2 JH */
    para[18]= 0.56;	/* Upd */
    para[19]=-0.4;	/* O  JH = U0/10 */
    para[20]=-0.8;	/* Cu JH = U0/10 */
    para[21]=-1.2;	/* Kpd */
    x_p=0;return 0;}
#endif 


